#ifndef KUBAS_STRING
#define KUBAS_STRING

#ifndef KUBAS_STRING_SIZE
#define KUBAS_STRING_SIZE 32
#endif

namespace kubas {

//template <uint8_t m_size = STRING_DEFAULT_SIZE>
class string {
	const static uint8_t m_size = KUBAS_STRING_SIZE;
	char m_data[KUBAS_STRING_SIZE];
	uint8_t pointer;
	char null;
public:
	/*string()
	{
		//m_size = STRING_DEFAULT_SIZE;
		for(pointer = 0; pointer != m_size; ++pointer)
			m_data[pointer] = 0;
		pointer = 0;
	}*/
	char operator[](const uint8_t &index) const
	{
		if(index < m_size)
			return m_data[index];
		return m_data[m_size-1];
	}

	char & operator[](const uint8_t &index)
	{
		if(index >= m_size)
		{
			return m_data[m_size-1];
		}
		pointer = index;
		return m_data[index];
	}
	uint8_t size() const
	{
		return m_size;
	}
	uint8_t get_pointer() const
	{
		return pointer;
	}
	uint8_t & get_pointer()
	{
		return pointer;
	}
	void operator = (const char *data)
	{
		for(pointer = 0; pointer != (m_size - 1); ++pointer)
		{
			m_data[pointer] = *(data+pointer);
			if(*(data+pointer) == 0)
				return;
		}
		m_data[m_size-1] = 0;
	}
	bool operator == (const char *data) const
	{
		for(uint8_t i = 0; i != m_size; ++i)
		{
			if(m_data[i] != *(data+i))
				return false;
			if(m_data[i] == 0)
				return true;
		}
		return true;
	}
	void operator --()
	{
		if(pointer != 0)
			--pointer;
		m_data[pointer] = 0;
	}
	void operator += (const char & ch)
	{
		m_data[pointer] = ch;
		if(pointer < (m_size-1))
			++pointer;
		else
			m_data[pointer] = 0;
	}
	/*void operator += (const char *data)
	{
		for(uint8_t i = 0; (*(data+i) != 0) && (pointer != m_size); ++i)
		{
			m_data[pointer] = *(data+i);
		}
	}*/
	void clear(const char ch = 0)
	{
		for(pointer = 0; pointer != m_size; ++pointer)
			m_data[pointer] = ch;
		pointer = 0;
	}
};

}

#endif
