#ifndef kubas_util
#define kubas_util

namespace kubas
{

template <typename T>
T abs(T data) {	return data<0?-data:data; }

template <typename T>
void memcpy(T* target, T* source, uint16_t length)
{
	for(uint16_t i = 0; i != length; ++i)
		*(target+i) = *(source+i);
}

template <typename T>
T pow(T base, uint8_t exp = 2)
{
	T res = base;
	if(exp == 0)
		return 1;
	while(--exp != 0)
		res *= base;
	return res;
}

template <typename T>
bool trim (T &n, T min, T max)
{
	if (n > max)
	{
		n = max;
		return false;
	}
	if (n < min)
	{
		n = min;
		return false;
	}
	return true;
}

template <typename T>
void swap(T &a, T &b)
{
	T temp = a;
	a = b;
	b = temp;
}
template <typename T>
void swap(T *a, T *b, uint16_t length = 1)
{
	T temp;
	for(uint16_t i = 0; i != length; ++i)
	{
		temp = *(a + i);
		*(a + i) = *(b + i);
		*(b + i) = temp;
	}
}

}
#endif
