//#include "basic.hpp"

volatile uint16_t servo[10];


ISR(TIMER3_COMPA_vect)
{
	static int8_t state = 0;
	static const uint8_t alignTable[10] = {5, 2, 4, 1, 3, 0, 9, 7, 8, 6};
	OCR3A = servo[alignTable[state]];
	if(state < 6)
	{	
		PORTB &= 0xF0;
		PORTE = ((PORTE & 0x03) | (1<<(state + 2)));
	}
	else if(state != 10)
	{
		PORTE &= 0x03;
		PORTB = ((PORTB & 0xF0) | (1<<(state - 6)));
	}
	else
	{
		state = -1;
	}
	++state;
}


void initSoftPWM()
{
	sei();
	DDRB = 0xFF;
	DDRD = (1<<4)|(1<<5)|(1<<6)|(1<<7);
	DDRE = (1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7);
	OCR0 = 0xFF;
	OCR1AL = 0xFF;
	OCR1BL = 0xFF;
	OCR1CL = 0xFF;
	TCCR0 = (1<<WGM00)|(1<<WGM01)|(1<<COM00)|(1<<COM01)|(1<<CS01);
	TCCR1A = (1<<COM1A1)|(1<<COM1A0)|(1<<COM1B1)|(1<<COM1B0)|(1<<COM1C1)|(1<<COM1C0)|(1<<WGM10);
	TCCR1B = (1<<WGM12)|(1<<CS11);
	OCR3A = 24000;
	TCCR3B = (1<<CS30)|(1<<WGM32);
	ETIMSK = (1<<OCIE3A);
	for(uint8_t i = 0; i != 10; ++i)
		servo[i] = 12000;
}


void setSoftPWM(int id, int value)	//value in (-1024;1024)
{
	servo[id] = 12000 + value * 12;
}
